// -*- C++ -*-
/*!
 * @file  BetaRnaCntl.cpp
 * @brief Beta Rna controll component
 * $Date$
 *
 * $Id$
 */

#include "BetaRnaCntl.h"

// Module specification
// <rtc-template block="module_spec">
static const char* betarnacntl_spec[] =
  {
    "implementation_id", "BetaRnaCntl",
    "type_name",         "BetaRnaCntl",
    "description",       "Beta Rna controll component",
    "version",           "0.1",
    "vendor",            "",
    "category",          "Generic",
    "activity_type",     "COMMUTATIVE",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

BetaRnaCntl::BetaRnaCntl(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_IDOut("ID", m_ID),
    m_ParamDirOut("ParamDir", m_ParamDir),
    m_TalkerMngPort("TalkerMng"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("ID", m_IDOut);
  registerOutPort("ParamDir", m_ParamDirOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_TalkerMngPort.registerConsumer("TalkerMng0", "TalkerMng", m_TalkerMng0);
  
  // Set CORBA Service Ports
  registerPort(m_TalkerMngPort);
  
  // </rtc-template>

}

BetaRnaCntl::~BetaRnaCntl()
{
}


/*
RTC::ReturnCode_t BetaRnaCntl::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t BetaRnaCntl::onExecute(RTC::UniqueId ec_id)
{
  char  sParam[256];
  char  sTalker[256];
  char* ptr;

  // wKE_R|[lg̃f[^fBNgpX͂
  fprintf( stdout, "Input Beta RNA param dir: " );
  fgets( sParam, 255, stdin );

  // bҖ̂͂ (_́A'?'͂)
  fprintf( stdout, "Input talker name.( ? to detect ): " );
  fgets( sTalker, 255, stdin );

  // f[^fBNgpX͂ꂽꍇ
  if( strlen( sParam ) > 1 ) {
    // s΁A܂ł͕Ƃ
    ptr = strchr( sParam, '\n' );
    if( ptr ) *ptr = 0x00;
    // f[^fBNgpXAf[^o̓|[gɐݒ肷
    m_ParamDir.data = CORBA::string_dup( sParam );
    // f[^fBNgpXAf[^o̓|[gAo͂
    m_ParamDirOut.write();
  }

  // bҖ̂͂ꂽꍇ
  if( strlen( sTalker ) > 1 ) {
    // '?'͂ꂽꍇ́AbID'-1'Ƃ ( = _[h )
    if( sTalker[0] == '?' ) {
      m_ID.data = -1;
    }
    // bҖ( '?'ȊO̕ )͂ꂽꍇ
    else {
      // s΁A܂ł͕Ƃ
      ptr = strchr( sTalker, '\n' );
      if( ptr ) *ptr = 0x00;
      
      // bҊǗ (TalkerMng) R|[lgAbID擾āAf[^o̓|[gɐݒ肷
      try {
        m_ID.data = m_TalkerMng0->GetID( sTalker );
      }
      catch(...) {
        fprintf( stdout, "Error in service port, check connection.\n" );
        return RTC::RTC_OK;
      }
    }
    // bIDAf[^o̓|[gAo͂
    m_IDOut.write();
  }

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t BetaRnaCntl::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaCntl::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void BetaRnaCntlInit(RTC::Manager* manager)
  {
    RTC::Properties profile(betarnacntl_spec);
    manager->registerFactory(profile,
                             RTC::Create<BetaRnaCntl>,
                             RTC::Delete<BetaRnaCntl>);
  }
  
};


