// -*- C++ -*-
/*!
 * @file  BetaRnaService.cpp
 * @brief BetaRna service port component
 * $Date$
 *
 * $Id$
 */

#include "BetaRnaService.h"

// Module specification
// <rtc-template block="module_spec">
static const char* betarnaservice_spec[] =
  {
    "implementation_id", "BetaRnaService",
    "type_name",         "BetaRnaService",
    "description",       "BetaRna service port component",
    "version",           "0.1",
    "vendor",            "",
    "category",          "Generic",
    "activity_type",     "COMMUTATIVE",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

BetaRnaService::BetaRnaService(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_BetaRnaPort("BetaRna"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  m_BetaRnaPort.registerProvider("BetaRna0", "BetaRna", m_BetaRna0);
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  registerPort(m_BetaRnaPort);
  
  // </rtc-template>

}

BetaRnaService::~BetaRnaService()
{
}


/*
RTC::ReturnCode_t BetaRnaService::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onExecute(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t BetaRnaService::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void BetaRnaServiceInit(RTC::Manager* manager)
  {
    RTC::Properties profile(betarnaservice_spec);
    manager->registerFactory(profile,
                             RTC::Create<BetaRnaService>,
                             RTC::Delete<BetaRnaService>);
  }
  
};


