/*
 @file   CPowerSpSp.h
 @brief  p[XyNgZo
 @author AdIn Research,Inc
 @date   2007/02/15
*/


#ifndef __C_POWER_SP_H__
#define __C_POWER_SP_H__

#include  <unistd.h>

#define WL_WDS_LPFRATE_DFL  (0.46)


class CPowerSp
{
private:
  double   m_dSamplingFreq;  // TvOg (Hz)
  int      m_iWF;            // ֐
  double   m_dLowerLim;      // g (Hz)
  double   m_dUpperLim;      // g (Hz)
  int      m_iDivCnt;        // p[XyNg

  // NOTE :  "m_dLowerLim < m_dUpperLim < m_dSamplingFreq / 2" łKv

private:
  int      m_nPnt;
  double*  m_pdIn;
  double*  m_pdLPF;
  double*  m_pdWF;
  double*  m_pdPower;
  double*  m_pdSmPower;   // Do not use
  double*  m_pdNormPower; // Do not use
  double*  m_pdReal;
  double*  m_pdImage;


  void clear( void );
  bool allocAll( int nPnt );
  bool loadParam( void );
  bool saveParam( void );

public:
  CPowerSp( void );
  ~CPowerSp( void );

  int CalcPower( int nPnt, const short* pPnt, int* piPCount, double** ppdPower );
  void GetParam( int* piWF, double* pdLower, double* pdUpper, int* piDev );
  void SetParam( int iWF, double dLower, double dUpper, int iDev );

};

#endif // __C_POWER_SP_H__
