// -*- C++ -*-
/*!
 * @file  GUI.cpp
 * @brief Demo GUI component
 * $Date$
 *
 * $Id$
 */

#include "GUI.h"

//	GUIǉ
#include	"CGuiCore.h"
extern CGuiCore	g_cCore;
//	܂

// Module specification
// <rtc-template block="module_spec">
static const char* gui_spec[] =
  {
    "implementation_id", "GUI",
    "type_name",         "GUI",
    "description",       "Demo GUI component",
    "version",           "0.1",
    "vendor",            "",
    "category",          "Generic",
    "activity_type",     "COMMUTATIVE",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

GUI::GUI(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_SizeIn("Size", m_Size),
    m_WaveIn("Wave", m_Wave),
    m_DataCountIn("DataCount", m_DataCount),
    m_DataAryIn("DataAry", m_DataAry),
    m_TrigegerOut("Trigeger", m_Trigeger),
    m_FileOut("File", m_File),
    m_SendSizeOut("SendSize", m_SendSize),
    m_SendWaveOut("SendWave", m_SendWave),
    m_TalkerMngPort("TalkerMng"),m_PowerInfoPort("PowerInfo"),m_BetaRnaPort("BetaRna"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("Size", m_SizeIn);
  registerInPort("Wave", m_WaveIn);
  registerInPort("DataCount", m_DataCountIn);
  registerInPort("DataAry", m_DataAryIn);
  
  // Set OutPort buffer
  registerOutPort("Trigeger", m_TrigegerOut);
  registerOutPort("File", m_FileOut);
  registerOutPort("SendSize", m_SendSizeOut);
  registerOutPort("SendWave", m_SendWaveOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_TalkerMngPort.registerConsumer("TalkerMng0", "TalkerMng", m_TalkerMng0);
  m_PowerInfoPort.registerConsumer("PowerInfo0", "PowerInfo", m_PowerInfo0);
  m_BetaRnaPort.registerConsumer("BetaRna0", "BetaRna", m_BetaRna0);
  
  // Set CORBA Service Ports
  registerPort(m_TalkerMngPort);
  registerPort(m_PowerInfoPort);
  registerPort(m_BetaRnaPort);
  
  // </rtc-template>

}

GUI::~GUI()
{
}


/*
RTC::ReturnCode_t GUI::onInitialize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t GUI::onActivated(RTC::UniqueId ec_id)
{
  // ̓f[^|[gɂ݂݂\B
  // ݂ǂݍŁA̓f[^|[g
  m_SizeIn.read();
  m_WaveIn.read();
  m_DataCountIn.read();
  m_DataAryIn.read();

  // ʃIuWFNg̏s
  g_cCore.OnActivate( this );

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GUI::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t GUI::onExecute(RTC::UniqueId ec_id)
{
  // f[^TCYVKɓ͂ꂽꍇ
  if( m_SizeIn.isNew() ) {

    // f[^TCYǂݍ
    m_SizeIn.read();
    // f[^ǂݍ
    m_WaveIn.read();

    // ʃIuWFNg̉擾nh֐Ăяo
    g_cCore.OnGetSound();
  }

  // ʂ̌VKɓ͂ꂽꍇ
  if( m_DataCountIn.isNew() ) {

    // ʂ̌ǂݍ
    m_DataCountIn.read();
    // ʂǂݍ
    m_DataAryIn.read();

    // ʃIuWFNgʎ擾nh֐Ăяo
    g_cCore.OnGetPower();
  }

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t GUI::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t GUI::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void GUIInit(RTC::Manager* manager)
  {
    RTC::Properties profile(gui_spec);
    manager->registerFactory(profile,
                             RTC::Create<GUI>,
                             RTC::Delete<GUI>);
  }
  
};


