/****************************************************************************
 *     Copyright      Advanced Intelligence Research, Inc.   1988-1991      *
 ****************************************************************************
 ****************************************************************************
 *
 *  File name  : Kstddef.h
 *
 *  Note       : Standard Definitions
 *
 * $Revision: 1.47 $
 * $Author: fujimaki $
 * $Date: 94/02/25 11:32:33 $
 * $Locker:  $
 *
 ****************************************************************************/
#if !defined(_KSTDDEF_H_)
#define _KSTDDEF_H_

/*****************************************************************************
                         For Compatibilities
 *****************************************************************************/

#if defined(SPARC)
# if !defined(SUNOS41)
#   define SUNOS41
# endif /* not SUNOS41 */
#endif /* SPARC */

#if defined(NEWS)
# if !defined(NEWS40)
#   define NEWS40
# endif /* not NEWS40 */
#endif /* NEWS */

#if defined(RISC_NEWS)
# if !defined(NEWS41)
#   define NEWS41
# endif /* not NEWS41 */
#endif /* RISC_NEWS */

#if defined(G200U)
# if !defined(RTUX386)
#   define RTUX386
# endif /* not RTUX386 */
#endif /* G200U */

#if defined(EWS4800)
# if !defined(EWSUXVR4)
#   define EWSUXVR4
# endif /* not EWSUXVR4 */
#endif /* EWS4800 */

#if defined(LUNA)
# if !defined(UNIOS_B)
#   define UNIOS_B
# endif /* not UNIOS_B */
#endif /* LUNA */

#if defined(LUNA88K)
# if !defined(UNIOS_MACH)
#   define UNIOS_MACH
# endif /* not UNIOS_MACH */
#endif /* LUNA88K */

#if defined(LUNA2U)
# if !defined(UNIOS_U)
#   define UNIOS_U
# endif /* not UNIOS_U */
#endif /* LUNA2U */

#if defined(IBM6000)
# if !defined(AIX3)
#   define AIX3
# endif /* not AIX3 */
#endif /* IBM6000 */

#if defined(HPUX)
# if !defined(HPUXA0901)
#   define HPUXA0901
# endif /* not HPUXA0901 */
#endif /* HPUX */

#if defined(LTC4)
# if !defined(LTC41)
#   define LTC41
# endif /* not LTC41 */
#endif /* LTC4 */

#if defined(WINDOWS)
# if !defined(MSWIN3)
#   define MSWIN3
# endif /* not MSWIN3 */
#endif /* WINDOWS */

/*****************************************************************************
                    ANSI C Dependent Descriptions
 *****************************************************************************/

/**STDEXT_BEGIN**/

#if defined(__STDC__) || defined(AIX3) || defined(MSC6) || defined(VMS)
# if !defined(USE_PROTOTYPE)
#   define USE_PROTOTYPE
# endif /* not USE_PROTOTYPE */
#endif /* __STDC__ || AIX3 || MSC6 || VMS */

#if !defined(PROTOTYPE)
# if defined(USE_PROTOTYPE)
#   define PROTOTYPE(fn, arg)       fn arg
# else
#   define PROTOTYPE(fn, arg)       fn ()
# endif /* not USE_PROTOTYPE */
#endif /* not PROTOTYPE */

/**STDEXT_END**/

/*****************************************************************************
                            Useful Macros
 *****************************************************************************/

#if defined(MSWIN3)
# define _FARPTR_           _far
#else /* not MSWIN3 */
# define _FARPTR_
#endif /* not MSWIN3 */

/*****************************************************************************
                    Machine Dependent Definitions
 *****************************************************************************/

#if defined(MACHINE_DEFINED)
# undef MACHINE_DEFINED
#endif /* MACHINE_DEFINED */

#if defined(VMS)                        /* VAX/VMS */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <types.h>
# include <file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <limits.h>
# include <math.h>
# include <perror.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <unixio.h>
# include <unixlib.h>
# if !defined(HAVE_SYS_ERRLIST_DECL)
#   define HAVE_SYS_ERRLIST_DECL
# endif /* not HAVE_SYS_ERRLIST_DECL */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '.'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (256)
# endif /* not MAXPATHLEN */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* VMS */

#if defined(RTUX386)            /* RT/UX386 -- TOSHIBA G200U */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/types.h>
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <getwidth.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <string.h>
  extern void *PROTOTYPE(malloc, (unsigned));
  extern int   PROTOTYPE(free, (void *));
  extern char *PROTOTYPE(getenv, (char *));
# if !defined(NO_VOID)
#   define NO_VOID
# endif /* not NO_VOID */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (PATH_MAX)
# endif /* not MAXPATHLEN */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* RTUX386 */

#if defined(EWSUXVR4)           /* EWS-UX/V(Rel4.0) -- NEC EWS4800/210 */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (255)
# endif /* not MAXPATHLEN */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* EWSUXVR4 */

#if defined(UNIOS_B)            /* 4.3BSD based -- OMRON LUNA, etc. */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <string.h>
  extern void *PROTOTYPE(malloc, (unsigned));
  extern int   PROTOTYPE(free, (void *));
  extern char *PROTOTYPE(getenv, (char *));
# if !defined(NO_VOID)
#   define NO_VOID
# endif /* not NO_VOID */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* UNIOS_B */

#if defined(UNIOS_U)            /* System V based -- OMRON LUNA, etc. */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <malloc.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <string.h>
  extern char *PROTOTYPE(malloc, (unsigned));
  extern int   PROTOTYPE(free, (char *));
  extern char *PROTOTYPE(getenv, (char *));
  extern long  PROTOTYPE(atol, (char *));
# if !defined(NO_VOID)
#   define NO_VOID
# endif /* not NO_VOID */
# if !defined(NO_SIZE_T)
#   define NO_SIZE_T
# endif /* not NO_SIZE_T */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* UNIOS_U */

#if defined(UNIOS_MACH)         /* UNIOS MACH 2.0 or later -- OMRON LUNA88K, etc */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <float.h>
# include <limits.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(HAVE_SYS_ERRLIST_DECL)
#   define HAVE_SYS_ERRLIST_DECL
# endif /* not HAVE_SYS_ERRLIST_DECL */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* UNIOS_MACH */

#if defined(NEWS41)             /* NEWS OS 4.1.x -- SONY NWS */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <float.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <unistd.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* NEWS41 */

#if defined(NEWS40)             /* NEWS OS 4.0.x -- SONY NWS */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* NEWS40 */

#if defined(SUNOS41)            /* SunOS 4.1.x -- Sun4, SPARCstation, etc. */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <signal.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <limits.h>
# include <math.h>
# include <memory.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <strings.h>
# include <unistd.h>
  extern void PROTOTYPE(perror, (char *));
  extern int  PROTOTYPE(fprintf, (FILE *, char *, ...));
  extern int  PROTOTYPE(printf, (char *, ...));
  extern int  PROTOTYPE(fputs, (char *, FILE *));
  extern int  PROTOTYPE(_flsbuf, (unsigned char, FILE *));
  extern int  PROTOTYPE(_filbuf, (FILE *));
  extern int  PROTOTYPE(fclose, (FILE *));
  extern int  PROTOTYPE(ungetc, (int, FILE *));
  extern int  PROTOTYPE(fseek, (FILE *, long, int));
  extern int  PROTOTYPE(toupper, (int));
  extern int  PROTOTYPE(rewind, (FILE *));
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* SUNOS41 */

#if defined(AIX3)               /* IBM6000 */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <strings.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* AIX3 */

#if defined(HPUXA0901)           /* HPUXA0901 */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <math.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <strings.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
#endif /* HPUXA0901 */

#if defined(SOLARIS2)                       /* IBM6000 */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <limits.h>
# include <float.h>
# include <values.h>
# include <locale.h>
# include <unistd.h>
# include <sys/file.h>
# include <sys/param.h>
# include <sys/utsname.h>
# include <errno.h>
# include <assert.h>
# include <ctype.h>
//# include <ja/xctype.h>
# include <malloc.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* SOLARIS2 */

#if defined(MSC6)               /* Microsoft C 6.0x (MS-DOS) */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <fcntl.h>
# include <float.h>
# include <limits.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(HAVE_SYS_ERRLIST_DECL)
#   define HAVE_SYS_ERRLIST_DECL
# endif /* not HAVE_SYS_ERRLIST_DECL */
# if !defined(__STDC__)
#   define __STDC__             /* can handle ANSI prototype, anyway */
# endif /* not __STDC__ */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '\\'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(MSDOS)
#   define MSDOS
# endif /* not MSDOS */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (_MAX_PATH)
# endif /* not MAXPATHLEN */
#endif /* MSC6 */

#if defined(LTC41)              /* Lattice C 4.1x (MS-DOS) */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <fcntl.h>
# include <float.h>
# include <limits.h>
# include <math.h>
# include <signal.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '\\'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(MSDOS)
#   define MSDOS
# endif /* not MSDOS */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (_MAX_PATH)
# endif /* not MAXPATHLEN */
#endif /* LTC41 */

#if defined(DJGPP)              /* DJGPP 1.x (MS-DOS) */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <sys/param.h>
# include <sys/file.h>
# include <assert.h>
# include <ctype.h>
# include <errno.h>
# include <limits.h>
# include <math.h>
# include <memory.h>
# include <signal.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# if !defined(MSDOS)
#   define MSDOS
# endif /* not MSDOS */
# if !defined(PATH_DELIM)
#   define PATH_DELIM       '/'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
/** fseek() of DJGPP v1.x does not work right in text mode (93.02.05 Toshi) **/
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "rb"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "wb"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "ab"
# endif /* not FOPEN_APPEND_MODE */
#endif /* DJGPP */

#if defined(THINKC5)               /* THINK C 5.0x (Macintosh) */
# if defined(MACHINE_DEFINED)
    FATAL: machine type specified more than once.
# endif /* MACHINE_DEFINED */
#define MACHINE_DEFINED
# include <assert.h>
# include <console.h>
# include <errno.h>
# include <float.h>
# include <limits.h>
# include <math.h>
# include <signal.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <unix.h>
# if !defined(PATH_DELIM)
#   define PATH_DELIM       ':'
# endif /* not PATH_DELIM */
# if !defined(STRUCT_ALIGN)
#   define STRUCT_ALIGN     (128)
# endif /* not STRUCT_ALIGN */
# if !defined(MAXPATHLEN)
#   define MAXPATHLEN       (255)
# endif /* not MAXPATHLEN */
# if !defined(FOPEN_READ_MODE)
#   define FOPEN_READ_MODE      "r"
# endif /* not FOPEN_READ_MODE */
# if !defined(FOPEN_WRITE_MODE)
#   define FOPEN_WRITE_MODE     "w"
# endif /* not FOPEN_WRITE_MODE */
# if !defined(FOPEN_APPEND_MODE)
#   define FOPEN_APPEND_MODE    "a"
# endif /* not FOPEN_APPEND_MODE */
# if !defined(isascii)
#   define isascii(c)           ((0xff & (c)) < 0x80)
# endif /* not isascii */
# if !defined(O_BINARY)
#   define O_BINARY         (0)
# endif /* not O_BINARY */
#endif /* THINKC5 */

#if !defined(MACHINE_DEFINED)
    FATAL: machine type is not specified.
#endif /* not MACHINE_DEFINED */

/*****************************************************************************
                                Types
 *****************************************************************************/

#if !defined(__STDC__) && !defined(const)
# define const
#endif /* not __STDC__ && not const */

#if defined(NO_SIZE_T)
  typedef unsigned int size_t;
#endif /* NO_SIZE_T */

#if !defined(GENPTR_T)
# define GENPTR_T
# if defined(NO_VOID)
    typedef char _FARPTR_ *GENPTR;
# else
    typedef void _FARPTR_ *GENPTR;
# endif /* not NO_VOID */
#endif /* not GENPTR_T */

/*****************************************************************************
                          Machine Dependents
 *****************************************************************************/
#if defined(MSDOS) && !defined(MS_DOS)
# define MS_DOS
#endif /* MSDOS && not MS_DOS */

#if !defined(HAVE_SYS_ERRLIST_DECL)
  extern int   errno, sys_nerr;
//  extern char *sys_errlist[];
#endif /* not HAVE_SYS_ERRLIST_DECL */

#if !defined(MSDOS)
  extern long        PROTOTYPE(gethostid, (void));
  extern char *PROTOTYPE(crypt, (const char *, const char *));
#endif /* not MSDOS */

/*****************************************************************************
                            Useful Macros
 *****************************************************************************/

#if !defined(COPY)
# if defined(NO_STRUCT_COPY)
#   define COPY(dst, src)       memcpy(&(dst), &(src), sizeof(dst))
# else /* not NO_STRUCT_COPY */
#   define COPY(dst, src)       (dst) = (src)
# endif /* not NO_STRUCT_COPY */
#endif /* not COPY */

/**STDEXT_BEGIN**/

#if !defined(DIM)
# define DIM(arr)           (sizeof(arr) / sizeof((arr)[0]))
#endif /* not DIM */

#if !defined(MIN)
# define MIN(a, b)          ((a) < (b) ? (a) : (b))
#endif /* not MIN */

#if !defined(MAX)
# define MAX(a, b)          ((a) > (b) ? (a) : (b))
#endif /* not MAX */

/**STDEXT_END**/

#if !defined(forever)
# define forever            for (;;)
#endif /* not forever */

#if !defined(NULL)
# define NULL           ((GENPTR) 0)
#endif /* not NULL */

# if !defined(DBL_MIN)
#   define DBL_MIN  (2.2250738585072015e-308) /* Min IEEE double exactly */
# endif /* not DBL_MIN */
# if !defined(DBL_MAX)
#   define DBL_MAX  (1.7976931348623158e+308) /* Max IEEE double exactly */
# endif /* not DBL_MAX */
# if !defined(USHRT_MAX)
#   define USHRT_MAX    ((unsigned short) 65535)
# endif /* not USHRT_MAX */
# if !defined(ULONG_MAX)
#   define ULONG_MAX    ((unsigned long) 4294967295)
# endif /* not ULONG_MAX */

typedef int BOOLEAN;
# if !defined(TRUE) && !defined(FALSE)
#   define FALSE        (0)
#   define TRUE         (1)
# endif /* not TRUE && not FALSE */

typedef unsigned char   byte;
typedef unsigned short  word;

#if !defined(CHAR)
#  define CHAR(x)     ((x) & 0x07f)           /* round up to  7bit */
#endif
#if !defined(BYTE)
#  define BYTE(x)     ((x) & 0x0ff)           /* round up to  8bit (byte) */
#endif
#if !defined(WORD)
#  define WORD(x)     ((x) & 0x0ffff)         /* round up to 16bit (word) */
#endif

#if !defined(HIBYTE)
#  define HIBYTE(x)   (((x) >> 8) & 0x0ff)    /* Hi-Byte of Short */
#endif
#if !defined(LOBYTE)
#  define LOBYTE(x)   ((x) & 0x0ff)           /* Low-Byte of Short */
#endif
#if !defined(HIWORD)
#  define HIWORD(x)   (((x) >> 16) & 0x0ffffL)/* Hi-Word of long */
#endif
#if !defined(LOWORD)
#  define LOWORD(x)   ((x) & 0x0ffffL)        /* Low-Word of long */
#endif

#if !defined(EOS)
#  define EOS         ('\0')
#endif
#if !defined(EOL)
#  define EOL         ('\n')
#endif
#if !defined(EOP)
#  define EOP         ('\14')
#endif
#if !defined(C_HT)
#  define C_HT        (0x09)
#endif
#if !defined(C_LF)
#  define C_LF        (0x0a)
#endif
#if !defined(C_FF)
#  define C_FF        (0x0c)
#endif
#if !defined(C_CR)
#  define C_CR        (0x0d)
#endif
#if !defined(C_SP)
#  define C_SP        (0x20)
#endif

#if defined(SMALL_INT)
  typedef short     integer;
#else /* not SMALL_INT */
# if defined(LARGE_INT)
  typedef long      integer;
# else /* not LARGE_INT */
  typedef int       integer;
# endif /* not LARGE_INT */
#endif /* not SMALL_INT */

#if defined(SMALL_REAL)
  typedef float     real;
#else /* not SMALL_REAL */
# if defined(LARGE_REAL)
  typedef double    real;
# else /* not LARGE_REAL */
  typedef double    real;
# endif /* not LARGE_REAL */
#endif /* not SMALL_REAL */

#define FMAXLNC         (1024)                  /* String Buffer Size */

/*****************************************************************************
                             Flag Values
 *****************************************************************************/

typedef enum {
    FLGREV = -1,
    FLGOFF,
    FLGON
} FLAG;

/*****************************************************************************
                             Exit Status
 *****************************************************************************/

#define SUCCEED         (0)
#define FAIL            (-1)

/*****************************************************************************
                                Scope
 *****************************************************************************/

#if 0
#if !defined(public)
# define public                 /* C's Default Scope */
#endif /* not public */
#if !defined(private)
# define private static         /* static == private */
#endif /* not private */
#endif

/*****************************************************************************
                              Registers
 *****************************************************************************/

#define REG0    register
#define REG1    register
#define REG2    register
#define REG3    register
#define REG4    register
#define REG5    register
#define REG6
#define REG7

#endif  /* not _KSTDDEF_H_ */
