/******************************************************************************
 *                 (C)Copyright 1996  AdIn Research, Inc.                     *
 ******************************************************************************
 *
 *  File name  : rnaSAusr.h
 *  Note       : Abstract API Definitions
 *  $Id: rnaSAusr.h,v 1.5 1999/11/16 06:34:31 fujimaki Exp $
 *
 *****************************************************************************/
#if !defined(_RNASAUSR_H_)
#define _RNASAUSR_H_

#include "rnaS1usr.h"
#include "rnaS2usr.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/**STDEXT_BEGIN**/
/********** for abstract API **********/
typedef unsigned long   LPMODE;
#define LPM_NONE        (0x00000000)
#define LPM_NORMRANGE   (0x00000001)
#define LPM_LMODE       (0x00000002)
#define LPM_LSTAT       (0x00000004)
#define LPM_LBGAIN      (0x00000008)
#define LPM_LTGAIN      (0x00000010)
#define LPM_RTGAIN      (0x00000020)
#define LPM_RBGAIN      (0x00000040)
#define LPM_CUTOFF      (0x00000080)
#define LPM_VARGAIN     (0x00000100)
#define LPM_VAGGAIN     (0x00000200)
#define LPM_HISTSIZE    (0x00000400)
#define LPM_EXTTHR      (0x00000800)
#define LPM_STDTHR      (0x00001000)
#define LPM_INITVAR     (0x00002000)
#define LPM_INITWEI     (0x00004000)
#define LPM_TWEITHR     (0x00008000)
#define LPM_BWEITHR     (0x00010000)
#define LPM_WINCGAIN    (0x00020000)
#define LPM_WDECGAIN    (0x00040000)
#define LPM_FUSMODE     (0x00080000)
#define LPM_FUSNUM      (0x00100000)
#define LPM_MINSQR      (0x00200000)
#define LPM_ADDVAR      (0x00400000)
#define LPM_RS2OUT      (0x08000000)

EXPORT FILE* PUBLIC PROTOTYPE(RS_OpenCSV, (const char*, int));
EXPORT Ferr  PUBLIC PROTOTYPE(RS_CloseCSV, (FILE*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS_ReadCSV, (FILE*, double*, int, double*, int));
EXPORT Ferr  PUBLIC PROTOTYPE(RS_WriteCSV, (FILE*, double*, int));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_DefaultLPara, (RS2DATA*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_LoadLPara, (const char*, RS2DATA*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_SaveLPara, (const char*, RS2DATA*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_SetLPara, (RS2DATA*, LPMODE, void*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_GetLPara, (RS2DATA*, LPMODE, void*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_FreeLPara, (RS2DATA*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_SetInputRange, (RS2DATA*, double*, double*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_GetInputRange, (RS2DATA*, double*, double*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_SetOutputRange, (RS2DATA*, double*, double*));
EXPORT Ferr  PUBLIC PROTOTYPE(RS2_GetOutputRange, (RS2DATA*, double*, double*));
/**STDEXT_END**/

#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif /* not _RNASAUSR_H_ */
